/etc/init.d/acix-cache is in nordugrid-arc-acix-cache 5.4.2-1build1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 | #!/bin/sh
# ARC cache index cache server
#
# chkconfig: 2345 75 25
# description: The ARC cache server collects cache information which \
# can be pulled by a cache index.
### BEGIN INIT INFO
# Provides: acix-cache
# Required-Start: $network $local_fs
# Required-Stop: $network $local_fs
# Should-Start: $time
# Should-Stop: $time
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: ARC cacheindex, cache server
# Description: The ARC cache server collects cache information which
# can be pulled by a cache index.
### END INIT INFO
# source function library
if [ -f /etc/init.d/functions ]; then
. /etc/init.d/functions
log_success_msg() {
echo -n "$@"
success "$@"
echo
}
log_warning_msg() {
echo -n "$@"
warning "$@"
echo
}
log_failure_msg() {
echo -n "$@"
failure "$@"
echo
}
elif [ -f /lib/lsb/init-functions ]; then
. /lib/lsb/init-functions
else
echo "Error: Cannot source neither init.d nor lsb functions"
exit 1
fi
PIDFILE=/var/run/acix-cache.pid
DEFAULT_LOGFILE=/var/log/arc/acix-cache.log
prog=twistd
RUN=yes
# sysconfig files
if [ -r /etc/sysconfig/nordugrid ]; then
. /etc/sysconfig/nordugrid
elif [ -r /etc/default/nordugrid ]; then
. /etc/default/nordugrid
fi
if [ -r /etc/sysconfig/acix-cache ]; then
. /etc/sysconfig/acix-cache
elif [ -r /etc/default/acix-cache ]; then
. /etc/default/acix-cache
fi
if [ `id -u` = 0 ] ; then
# Debian does not have /var/lock/subsys
if [ -d /var/lock/subsys ]; then
LOCKFILE=/var/lock/subsys/acix-cache
else
LOCKFILE=/var/lock/acix-cache
fi
else
LOCKFILE=$HOME/acix-cache.lock
fi
do_start() {
if [ "$RUN" != "yes" ] ; then
echo "acix-cache service is disabled, please adjust the configuration to your"
echo "needs and then set RUN to 'yes' in /etc/default/acix-cache to enable it."
return 0
fi
# ARC_CONFIG
if [ "x$ARC_CONFIG" = "x" ] && [ -r /etc/arc.conf ]; then
ARC_CONFIG=/etc/arc.conf
fi
if [ ! -r "$ARC_CONFIG" ]; then
log_failure_msg "ARC configuration not found (usually /etc/arc.conf)"
exit 1
fi
echo -n "Starting ARC cache server..."
# Check if we are already running
if [ -f $PIDFILE ]; then
read pid < $PIDFILE
if [ "x$pid" != "x" ]; then
ps -p "$pid" -o comm 2>/dev/null | grep "^$prog$" 1>/dev/null 2>/dev/null
if [ $? -eq 0 ] ; then
log_success_msg "already running (pid $pid)"
return 0
fi
fi
rm -f "$PIDFILE" "$LOCKFILE"
fi
CONFIG_SECTION=acix\\/cacheserver
# read in cacheserver section from arc.conf
# this will put the read values into the environment, e.g., $logfile
eval `sed -e 's/[[:space:]]*\=[[:space:]]*/=/g' \
-e 's/;.*$//' \
-e 's/[[:space:]]*$//' \
-e 's/^[[:space:]]*//' \
-e "s/^\(.*\)=\([^\"']*\)$/\1=\"\2\"/" \
< $ARC_CONFIG \
| sed -n -e "/^\[$CONFIG_SECTION\]/,/^\s*\[/{/^[^;].*\=.*/p;}" `
LOGFILE=${logfile:-$DEFAULT_LOGFILE}
LOGD=`dirname $LOGFILE`
LOGN=`basename $LOGFILE`
if [ ! -d $LOGD ]; then
mkdir -p $LOGD
fi
APPSTART="
from acix import cacheserver;
from twisted.python import log;
from twisted.python.logfile import LogFile;
application = cacheserver.createApplication();
log.startLogging(LogFile('$LOGN', '$LOGD', rotateLength=1000000, maxRotatedFiles=25))
"
TACFILE=`mktemp` || exit 1
echo $APPSTART > $TACFILE
$prog --pidfile $PIDFILE -y $TACFILE -l $LOGFILE
RETVAL=$?
rm -f $TACFILE
if [ $RETVAL -eq 0 ]; then
touch $LOCKFILE
log_success_msg
else
log_failure_msg
fi
return $RETVAL
}
do_stop() {
echo -n "Stopping ARC cache server..."
if [ -f "$PIDFILE" ]; then
read pid < "$PIDFILE"
if [ ! -z "$pid" ] ; then
kill "$pid"
RETVAL=$?
if [ $RETVAL -eq 0 ]; then
log_success_msg
else
log_failure_msg
fi
timeout=2; # for stopping nicely
while ( ps -p "$pid" -o comm 2>/dev/null | grep "^$prog$" 1>/dev/null 2>/dev/null ) && [ $timeout -ge 1 ] ; do
sleep 1
timeout=$(($timeout - 1))
done
[ $timeout -lt 1 ] && kill -9 "$pid" 1>/dev/null 2>&1
rm -f "$PIDFILE" "$LOCKFILE"
else
RETVAL=1
log_failure_msg "$prog shutdown - pidfile is empty"
fi
else
RETVAL=0
log_success_msg "$prog shutdown - already stopped"
fi
return $RETVAL
}
do_status() {
if [ -f "$PIDFILE" ]; then
read pid < "$PIDFILE"
if [ "$pid" != "" ]; then
if ps -p "$pid" > /dev/null; then
echo "$1 (pid $pid) is running..."
return 0
fi
echo "$1 stopped but pid file exists"
return 1
fi
fi
if [ -f $LOCKFILE ]; then
echo "$1 stopped but lockfile exists"
return 2
fi
echo "$1 is stopped"
return 3
}
do_restart() {
do_stop
do_start
}
case "$1" in
start)
do_start
;;
stop)
do_stop
;;
restart|reload|force-reload)
do_restart
;;
condrestart|try-restart)
[ -f $LOCKFILE ] && do_restart || :
;;
status)
do_status $prog
;;
*)
echo "Usage: $0 {start|stop|restart|status|reload|condrestart|try-restart}"
exit 1
;;
esac
exit 0
|